<bugID>1096013<Summary>[e10s] Improve perceived session restore duration</Summary><Description>Restoring a session with e10s seems to take a little more time currently as described in bug 1037179. The perception of that process plays quite a big role esp. with restore_on_demand=true. We can do better here:

1) The history of selected tabs should be restored first. We'll send messages to the docShells of all tabs we restore and so the more important and visible ones can react first and start loading their pages.

2) We send a message to restore the history and only after that is done the parent receives a message and sets tab label and icon. We need to do this afterwards because restoring the history resets label and icon. We however should also do this before sending the "restore history" message, that helps improving the whole UX a lot with my session as the response can take ~1s even on my machine.</Description></bugID>